﻿using CommunityToolkit.Maui.Converters;

namespace TestProject;

/// <summary>
/// 메인 페이지
/// </summary>
public partial class MainPage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region X0 - X0

    /// <summary>
    /// X0
    /// </summary>
    public int X0 { get; set; }

    #endregion
    #region X1 - X1

    /// <summary>
    /// X1
    /// </summary>
    public int X1 { get; set; }

    #endregion
    #region X2 - X2

    /// <summary>
    /// X2
    /// </summary>
    public int X2 { get; set; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainPage()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        X0 = 100;
        X1 = 300;
        X2 = 200;

        MultiMathExpressionConverter converter = new MultiMathExpressionConverter();

        List<BindingBase> bindingBaseList = new List<BindingBase>();

        bindingBaseList.Add(new Binding("X0"));
        bindingBaseList.Add(new Binding("X1"));
        bindingBaseList.Add(new Binding("X2"));

        MultiBinding binding = new MultiBinding();

        binding.ConverterParameter = "x0 + x1 + x2";
        binding.Converter          = converter;
        binding.Bindings           = bindingBaseList;

        this.label.SetBinding(Label.TextProperty, binding);

        BindingContext = this;
    }

    #endregion
}